/******************************************
	QROQS over to C Language !!
	Writen by SAKAMOTO pgate203
	Last Update : 17:13 2003/11/23
******************************************/
#include "QROQS.h"

BSPetri *bsp_init(
	int place_size,
	int tran_size,
	int uhzi_size,
	int kem_size,

	int init_token[],
	int init_value[],
	int init_fire[],
	int in_place_size[],
	int out_place_size[],
	int (*func[])(int*),
	int (*guard[])(int*),
	int in_place[],
	int out_place[],
	int joint_size[],
	int joints[]
	)
{
	int i,j;
	int obj_size;
	BSPetri *bsp;
	Place *place;
	Tran *tran;
	Uhzi *uhzi;
	Kem *kem;
	Object *obj;
	
	bsp = (BSPetri *)malloc(sizeof(BSPetri));
	if(bsp==NULL) return NULL;

	memset(bsp, 0, sizeof(BSPetri) );
	
	bsp->place_size	= place_size;
	bsp->tran_size	= tran_size;
	bsp->uhzi_size	= uhzi_size;
	bsp->kem_size	= kem_size;
	bsp->obj_size	= obj_size	= tran_size + uhzi_size + kem_size;
	
	place	= bsp->place	= (Place*)malloc(sizeof(Place)*place_size);
	tran	= bsp->tran		= (Tran*)malloc(sizeof(Tran)*tran_size);
	uhzi	= bsp->uhzi		= (Uhzi*)malloc(sizeof(Uhzi)*uhzi_size);
	kem		= bsp->kem		= (Kem*)malloc(sizeof(Kem)*kem_size);
	obj		= bsp->obj		= (Object*)malloc(sizeof(Object)*obj_size);

	bsp->init_token = (int*)malloc(sizeof(int)*place_size);
	bsp->init_value = (int*)malloc(sizeof(int)*place_size);
	bsp->init_fire = (int*)malloc(sizeof(int)*obj_size);

	if(place==NULL || tran==NULL || uhzi==NULL || kem==NULL || obj==NULL
		|| bsp->init_token==NULL || bsp->init_fire==NULL || bsp->init_value==NULL){
		bsp_exit(bsp);
		return NULL;
	}

	memset(place, 0, sizeof(Place)*place_size);
	memset(tran, 0, sizeof(Tran)*tran_size);
	memset(uhzi, 0, sizeof(Uhzi)*uhzi_size);
	memset(kem, 0, sizeof(Kem)*kem_size);
	memset(obj, 0, sizeof(Object)*obj_size);

	// Initializing Object
	{
		int in_p, out_p, jt_p;
		in_p = 0;
		out_p = 0;
		jt_p = 0;
		for(i=0; i<obj_size; i++){
			obj[i].in_place_size	= in_place_size[i];
			obj[i].out_place_size	= out_place_size[i];
			obj[i].joint_size	= joint_size[i];
			obj[i].in_place	 = (Place**)malloc(sizeof(Place*)*in_place_size[i]);
			obj[i].out_place = (Place**)malloc(sizeof(Place*)*out_place_size[i]);
			obj[i].joints = (Object**)malloc(sizeof(Object*)*joint_size[i]);

			if(obj[i].in_place==NULL || obj[i].out_place==NULL || obj[i].joints==NULL){
				bsp_exit(bsp);
				return NULL;
			}

			for(j=0; j<in_place_size[i]; j++,in_p++){
				obj[i].in_place[j]	= &place[in_place[in_p]];
			}
			for(j=0; j<out_place_size[i]; j++,out_p++){
				obj[i].out_place[j] = &place[out_place[out_p]];
			}
			for(j=0; j<joint_size[i]; j++,jt_p++){
				obj[i].joints[j] = & obj[ joints[jt_p] ];
			}
			bsp->init_fire[i] = init_fire[i];
		}
	}

	// Initializing Place
	for(i=0; i<place_size; i++){
		bsp->init_token[i] = init_token[i];
		bsp->init_value[i] = init_value[i];
	}

	// Initializing Transition
	{
		int tf_p;
		tf_p=0;
		for(i=0; i<tran_size; i++){
			tran[i].in_value = (int*)malloc(sizeof(int)*obj[i].in_place_size);
			tran[i].guard = guard[i];
			tran[i].func = (int(**)(int*))malloc(sizeof( int(*)(int*) )*obj[i].out_place_size);
			
			if(tran[i].in_value==NULL || tran[i].func==NULL){
				bsp_exit(bsp);
				return NULL;
			}

			obj[i].type = _TRAN;
			obj[i].prim.tran = &tran[i];
			for(j=0; j<obj[i].out_place_size; j++,tf_p++){
				tran[i].func[j] = func[tf_p];
			}
		}
	}

	// Initializing Uhzi
	for(i=0; i<uhzi_size; i++){
		obj[tran_size+i].type = _UHZI;
		obj[tran_size+i].prim.uhzi = &uhzi[i];
	}

	// Initializing Kemmakix
	for(i=0; i<kem_size; i++){
		obj[tran_size+uhzi_size+i].type = _KEM;
		obj[tran_size+uhzi_size+i].prim.kem = &kem[i];
	}

	return bsp;
}

int bsp_io(BSPetri *bsp, int u_dmax[], int k_dmax[], int **input_data, int **output_data)
{
	int i;
	// Initializing Uhzi
	for(i=0; i<bsp->uhzi_size; i++){
		bsp->uhzi[i].dmax = u_dmax[i];
		if(input_data[i]==NULL) return 0;
		bsp->uhzi[i].data = input_data[i];
	}

	// Initializing Kemmakix
	for(i=0; i<bsp->kem_size; i++){
		bsp->kem[i].dmax = k_dmax[i];
		if(output_data[i]==NULL) return 0;
		bsp->kem[i].data = output_data[i];
	}

	return 1;
}

int bsp_io_data(BSPetri *bsp, int u_dmax[], int k_dmax[], char *in[])
{
	int i,j;

	for(i=0;i<bsp->uhzi_size;i++){
		bsp->uhzi[i].dmax = u_dmax[i];
		bsp->uhzi[i].data = (int *)malloc(sizeof(int)*u_dmax[i]);

		for(j=0;j<u_dmax[i];j++){
			bsp->uhzi[i].data[j] = in[i][j] - '0';
		}
	}

	for(i=0;i<bsp->kem_size;i++){
		bsp->kem[i].dmax = k_dmax[i];
		bsp->kem[i].data = (int *)malloc(sizeof(int)*k_dmax[i]);
	}

	return 1;
}

void bsp_in_print( BSPetri *bsp )
{
	int i,j;
	for(i=0;i<bsp->uhzi_size;i++){
		printf("in%d : ",i);
		for(j=0;j<bsp->uhzi[i].dmax;j++){
			printf("%d",bsp->uhzi[i].data[j] & 0x00000001);
		}
		printf("\n");
	}
}

int bsp_reset(BSPetri *bsp)
{
	int i;
	Object *obj;
	Place *place;

	if(bsp==NULL) return 0;

	// Reseting Token
	place = &bsp->place[0];
	for(i=0; i<bsp->place_size; i++){
		place[i].token_state = bsp->init_token[i];
		place[i].token_value = bsp->init_value[i];
	}

	// Reseting Fire
	obj = &bsp->obj[0];
	for(i=0; i<bsp->obj_size; i++){
		obj[i].state = bsp->init_fire[i];
	}

	return 1;
}
/*
//{c
int bsp_run(BSPetri *bsp, int reset)
{
	int i;
	int *event, event_top, event_last, event_size;
	Object *obj;
	Tran *tran;
	Uhzi *uhzi;
	Kem *kem;
	int in_next_state, out_next_state;

	if(bsp==NULL) return 1;

	if(reset){
		bsp_reset( bsp );
	}
	
	//uhzi
	uhzi = &bsp->uhzi[0];
	for(i=0;i<bsp->uhzi_size;i++){
		uhzi[i].ptr = 0;
	}
	//kem
	kem = &bsp->kem[0];
	for(i=0;i<bsp->kem_size;i++){
		kem[i].ptr = 0;
	}
	obj = &bsp->obj[0];

	event_size = bsp->obj_size + 1;
	event = (int *)malloc(sizeof(int)*event_size);
	if(event==NULL) return 1;

	// Adding all objects into event list.
	event_top=0;
	for(event_last=0;event_last<bsp->obj_size;event_last++){
		event[event_last] = event_last;
		obj[event_last].event = 1;
	}

	//printf("event start\n");
	// Event start.
	for(;event_top!=event_last;){
		
		//for(i=0;i<event_size;i++)printf("%d ",event[i]);printf("\n");getchar();
		
		obj = &bsp->obj[event[event_top]];
		
	//	printf("%d	type %d \n",event[event_top],obj->type);
		
		// Cheching output place
		out_next_state = obj->state==0 ? _WTOKEN_OFF : _BTOKEN_OFF;
		for(i=0;i<obj->out_place_size;i++){
			if(!(obj->out_place[i]->token_state == out_next_state)){
				goto OBJ_END;
			}
		}
		
		// Checking input place
		in_next_state = obj->state==0 ? _BTOKEN_EXIST : _WTOKEN_EXIST;
		for(i=0;i<obj->in_place_size;i++){
			if(!(obj->in_place[i]->token_state == in_next_state)){
				goto OBJ_END;
			}
		}
		
		// Woking objects
		switch(obj->type){
		case _TRAN:
			tran = obj->prim.tran;
			// Get Token Value.
			if(in_next_state == _BTOKEN_EXIST){
				for(i=0;i<obj->in_place_size;i++){
					tran->in_value[i] = obj->in_place[i]->token_value;
				}
			}
			// Checking Guard tarm
			if(tran->guard!=NULL){
				if(tran->guard(tran->in_value)==0){
					goto OBJ_END;
				}
			}
			// Fire !
			//printf("	fire !\n");
			for(i=0;i<obj->out_place_size;i++){
				obj->out_place[i]->token_value = tran->func[i](tran->in_value);
			}
			break;
		case _UHZI:
//			printf("uhzi\n");
			uhzi = obj->prim.uhzi;
			// No data. No industry.
			if(uhzi->ptr == uhzi->dmax) goto OBJ_END;
			// Get Token Value.
			if(out_next_state == _WTOKEN_OFF){
				obj->out_place[0]->token_value = uhzi->data[uhzi->ptr];
			}
			// Next data
			if(out_next_state == _BTOKEN_OFF) uhzi->ptr++;
			
	//		printf("	industry\n");
			
			break;
		case _KEM:
			kem = obj->prim.kem;
			// No size No Consum
			if(kem->ptr == kem->dmax) goto OBJ_END;
			// Get Token Data
			if(in_next_state == _BTOKEN_EXIST){
				kem->data[kem->ptr] = obj->in_place[0]->token_value;
			}
			// Next data
			if(in_next_state == _WTOKEN_EXIST) kem->ptr++;
			//printf("	Consum\n");
			break;
		}
		
		// Put Token to output places.
		for(i=0;i<obj->out_place_size;i++){
			obj->out_place[i]->token_state = in_next_state;
		}
		out_next_state ^= 0x00000010;
		// Get Token from input places.
		for(i=0;i<obj->in_place_size;i++){
			obj->in_place[i]->token_state = out_next_state;
		}

		obj->state = 1 - obj->state;
	
		// Adding events.
		for(i=0;i<obj->joint_size;i++){
			//	printf("add event\n");
			if(bsp->obj[obj->joints[i]].event) continue;
			bsp->obj[obj->joints[i]].event = 1;
			event[event_last] = obj->joints[i];
			event_last++;
			if(event_last==event_size) event_last=0;
		}
		
OBJ_END:
		
		obj->event = 0;
		event_top++;
		if(event_top==event_size) event_top=0;
	}

	free(event);

	return 0;
}
*/

int bsp_run(BSPetri *bsp, int reset)
{
	int i,o;
	Object *obj;
	Tran *tran;
	Uhzi *uhzi;
	Kem *kem;
	int in_next_state, out_next_state;

	if(bsp==NULL) return 1;

	if(reset){
		bsp_reset( bsp );
	}
	
	//uhzi
	uhzi = &bsp->uhzi[0];
	for(i=0;i<bsp->uhzi_size;i++){
		uhzi[i].ptr = 0;
	}
	//kem
	kem = &bsp->kem[0];
	for(i=0;i<bsp->kem_size;i++){
		kem[i].ptr = 0;
	}
	obj = &bsp->obj[0];

	// Adding all objects into event list.
	for(i=0;i<bsp->obj_size;i++){
		obj[i].event = 1;
	}

	//printf("event start\n");
	// Event start.
	for(obj=(Object*)1;obj!=NULL;){

		obj = NULL;

		for(o=0;o<bsp->obj_size;o++){
			if(bsp->obj[o].event==0) continue;
		
		obj = &bsp->obj[o];
		
	//	printf("%d	type %d \n",o,obj->type);
		
		// Cheching output place
		out_next_state = obj->state==0 ? _WTOKEN_OFF : _BTOKEN_OFF;
		for(i=0;i<obj->out_place_size;i++){
			if(!(obj->out_place[i]->token_state == out_next_state)){
				goto OBJ_END;
			}
		}
		// Checking input place
		in_next_state = obj->state==0 ? _BTOKEN_EXIST : _WTOKEN_EXIST;
		for(i=0;i<obj->in_place_size;i++){
			if(!(obj->in_place[i]->token_state == in_next_state)){
				goto OBJ_END;
			}
		}

		// Woking objects
		switch(obj->type){
		case _TRAN:
			tran = obj->prim.tran;
			// Get Token Value.
			if(in_next_state == _BTOKEN_EXIST){
				for(i=0;i<obj->in_place_size;i++){
					tran->in_value[i] = obj->in_place[i]->token_value;
				}
			}
			// Checking Guard tarm
			if(tran->guard!=NULL){
				if((tran->guard(tran->in_value) & 0x00000001) == 0){
					goto OBJ_END;
				}
			}
			// Fire !
			//printf("	fire !\n");
			for(i=0;i<obj->out_place_size;i++){
				if(tran->func[i] != NULL){
					obj->out_place[i]->token_value = tran->func[i](tran->in_value);
				}
				else{
					obj->out_place[i]->token_value = 0;	// for the moment
				}
			}
			break;
		case _UHZI:
//			printf("uhzi\n");
			uhzi = obj->prim.uhzi;
			// No data. No industry.
			if(uhzi->ptr == uhzi->dmax) goto OBJ_END;
			// Get Token Value.
			if(out_next_state == _WTOKEN_OFF){
				obj->out_place[0]->token_value = uhzi->data[uhzi->ptr];
			}
			// Next data
			if(out_next_state == _BTOKEN_OFF) uhzi->ptr++;		
		//	printf("	industry\n");
			break;
		case _KEM:
			kem = obj->prim.kem;
			// No size No Consum
			if(kem->ptr == kem->dmax) goto OBJ_END;
			// Get Token Data
			if(in_next_state == _BTOKEN_EXIST){
				kem->data[kem->ptr] = obj->in_place[0]->token_value;
			}
			// Next data
			if(in_next_state == _WTOKEN_EXIST) kem->ptr++;
		//	printf("	Consum %d\n",kem->ptr);
			break;
		}
		
		// Put Token to output places.
		for(i=0;i<obj->out_place_size;i++){
			obj->out_place[i]->token_state = in_next_state;
		}
		out_next_state ^= 0x00000010;
		// Get Token from input places.
		for(i=0;i<obj->in_place_size;i++){
			obj->in_place[i]->token_state = out_next_state;
		}

		obj->state = 1 - obj->state;
	
		// Adding events.
		for(i=0;i<obj->joint_size;i++){
		//		printf("add event\n");
			obj->joints[i]->event = 1;
		}
		
OBJ_END:
		
		obj->event = 0;

		}
	}

	return 0;
}


void bsp_out_print( BSPetri *bsp )
{
	int i,j;
	for(i=0;i<bsp->kem_size;i++){
		printf("out%d : ",i);
		for(j=0;j<bsp->kem[i].ptr;j++){
			printf("%d",bsp->kem[i].data[j] & 0x00000001);
		}
		printf("\n");
	}
}

void bsp_io_exit(BSPetri *bsp)
{
	int i;
	for(i=0;i<bsp->uhzi_size;i++)	free(bsp->uhzi[i].data);
	for(i=0;i<bsp->kem_size;i++)	free(bsp->kem[i].data);
}

void bsp_exit(BSPetri *bsp)
{
	int i;

	if(bsp==NULL) return;

	if(bsp->place) free(bsp->place);

	if(bsp->tran){
		for(i=0;i<bsp->tran_size;i++){
			if(bsp->tran[i].in_value)	free( bsp->tran[i].in_value );
			if(bsp->tran[i].func)		free( bsp->tran[i].func );
		}
		free(bsp->tran);
	}

	if(bsp->uhzi)	free(bsp->uhzi);
	if(bsp->kem)	free(bsp->kem);
	
	if(bsp->obj){
		for(i=0;i<bsp->obj_size;i++){
			if(bsp->obj[i].joints)		free( bsp->obj[i].joints );
			if(bsp->obj[i].in_place)	free( bsp->obj[i].in_place );
			if(bsp->obj[i].out_place)	free( bsp->obj[i].out_place );
		}
		free(bsp->obj);
	}

	if(bsp->init_token)	free(bsp->init_token);
	if(bsp->init_fire)	free(bsp->init_fire);
	if(bsp->init_value)	free(bsp->init_value);

	free(bsp);
}

/// EOF ///
