/******************************************
	QROQS over to C Language !!
	Writen by SAKAMOTO pgate203
	Last Update : 17:13 2003/11/23
******************************************/
#ifndef BitSerialPetriNetC_H_INCLUDED
#define BitSerialPetriNetC_H_INCLUDED

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>

#define _BTOKEN_OFF		0x00000010
#define _WTOKEN_OFF		0x00000000
#define _BTOKEN_EXIST	0x00000011
#define _WTOKEN_EXIST	0x00000001

typedef struct place {
	int token_state;
	int token_value;
} Place;

typedef struct transition {
	int (*guard)(int *);
	int (**func)(int *);
	int *in_value;
} Tran;

typedef struct uhzi {
	int ptr, dmax;
	int *data;
} Uhzi;

typedef struct kemmakix {
	int ptr, dmax;
	int *data;
} Kem;

typedef struct object {
	int type;
	union {
		Tran *tran;
		Uhzi *uhzi;
		Kem  *kem;
	} prim;
	int in_place_size, out_place_size, joint_size;
	Place **in_place, **out_place;
	struct object **joints;
	int state;
	int event;
} Object;

enum {
	_NONE,
	_PLACE,
	_TRAN,
	_UHZI,
	_KEM
};

typedef struct bspetri {
	int place_size, tran_size, uhzi_size, kem_size, obj_size;
	Place *place;
	Tran *tran;
	Uhzi *uhzi;
	Kem *kem;
	Object *obj;
	int *init_token, *init_value, *init_fire;
} BSPetri;

BSPetri *bsp_init(
	int place_size,
	int tran_size,
	int uhzi_size,
	int kem_size,
	
	int init_token[],
	int init_value[],
	int init_fire[],
	int in_place_size[],
	int out_place_size[],
	int (*func[])(int*),
	int (*guard[])(int*),
	int in_place[],
	int out_place[],
	int joint_size[],
	int joints[]
	);
int bsp_io(BSPetri *bsp, int u_dmax[], int k_dmax[], int **input_data, int **output_data);
int bsp_io_data(BSPetri *bsp, int u_dmax[], int k_dmax[], char *in[]);
void bsp_in_print( BSPetri *bsp );
int bsp_reset(BSPetri *bsp);
int bsp_run(BSPetri *bsp, int reset);
void bsp_out_print( BSPetri *bsp );
void bsp_io_exit(BSPetri *bsp);
void bsp_exit(BSPetri *bsp);

#endif

// EOF //
