//
// created by QROQS
//	macro    : delay add script
//	function : create delay.vnet by delay.data & trafunc.rep
//	update   : 19:25 2003/08/16
//
#include<stdio.h>
#include<string.h>
#include<time.h>
/*
#pragma warning( disable : 4786 )
#include<map>
using namespace std;
*/

//#define BUF_DELAY 100	//BUF1
//#define BUF_DELAY 80	//0.6INV1*2
#define BUF_DELAY 80	//0.35INV1*2

double get_rep_delay(FILE *fp,int func_n)
{
	double rep_delay=-1;
	char rdata[256];

	while(fgets(rdata,255,fp)!=NULL){
		if(!strncmp(rdata,"Report : timing",15)) break;
	}

	char buf[100];
	sprintf(buf,"Design : trafunc_%d",func_n);
	while(fgets(rdata,255,fp)!=NULL){
		if(!strncmp(rdata,buf,strlen(buf))) break;
	}

	while(fgets(rdata,255,fp)!=NULL){
		if(strncmp(rdata,"  data arrival time",19)==0){
			sscanf(rdata,"  data arrival time %lf\n",&rep_delay);
			break;
		}
		else if(strncmp(rdata,"No paths.",9)==0){
			rep_delay=0.0;
			break;
		}
	}

	return rep_delay;
}

int delay_to_buf(int delay)
{
	int n,m;
	n=delay/BUF_DELAY;
	m=delay-n*BUF_DELAY;
	if(m>0) n++;
	return n;
}

void write_vnet(FILE *fp, int tra_id, int tra_output, int delay_buf_n ,int total_delay_up)
{

	int i;

	fprintf(fp,"module delay_%d_%d(\n",tra_id,tra_output);
	fprintf(fp,"	req_in, req_out\n");
	fprintf(fp,");\n");

	fprintf(fp,"input	req_in;\n");
	fprintf(fp,"output	req_out;\n");

/*
//BUF1Œxt
	fprintf(fp,"	wire w1,w%d;\n",delay_buf_n+1);
	fprintf(fp,"	assign	w1 = req_in;\n");
	for(i=1;i<=delay_buf_n;i++){
		fprintf(fp,"	BUF1 buf%d(.A(w%d), .Y(w%d));\n",i,i,i+1);
	}
	fprintf(fp,"	assign	req_out = w%d;\n",delay_buf_n+1);
*/

//INV1Œxt
	if(delay_buf_n==0){
		fprintf(fp,"	assign req_out = req_in;\n");
	}
	else{
		fprintf(fp,"	wire w1,w%d;\n",delay_buf_n*2+1);
		fprintf(fp,"	assign	w1 = req_in;\n");
		for(i=1;i<=delay_buf_n*2;i++){
			fprintf(fp,"	INV1 buf%d(.A(w%d), .Y(w%d));\n",i,i,i+1);
		}
		fprintf(fp,"	assign	req_out = w%d;\n",delay_buf_n*2+1);
	}

//̂܂܁AeXgp
//	fprintf(fp,"	assign	#%d req_out=req_in;\n",total_delay_up);

	fprintf(fp,"endmodule\n");
}

int main(void)
{

	char vdata[256];
	int func_n;
	double rep_delay,slack;
	int i;


	FILE *data_fp;
	data_fp=fopen("delay.data","r");

	fgets(vdata,255,data_fp);
	sscanf(vdata,"%d,%lf;\n",&func_n,&slack);

	int *delays = new int[func_n];

	FILE *rep_fp;
	rep_fp=fopen("trafunc.rep","r");
	for(i=1;i<=func_n;i++){

		//|[gt@CxԂ擾
		rep_delay = get_rep_delay(rep_fp, i);
		if(rep_delay==-1){
			printf("|[gt@CxԂ擾ł܂ł\n");
			break;
		}
		printf("trafunc %d  rep delay  %f ns\n",i ,rep_delay);

		delays[i-1] = (int)( rep_delay * 1000 );

	}
	fclose(rep_fp);



	FILE *vnet_fp;
	vnet_fp=fopen("delay.vnet","w");
	int tra_id, tra_output;
	int delay_up,delay_down,total_delay_up;
	int delay_buf_n;

	while(fgets(vdata,255,data_fp)!=NULL){
		sscanf(vdata,"%d,%d,%d,%d,%d;"
			,&tra_id,&tra_output,&delay_up,&delay_down,&func_n);

		if(func_n==0) total_delay_up=delay_up;
		else total_delay_up = delays[func_n-1] + delay_up;
		total_delay_up += (int)( total_delay_up * slack);
		printf("	delay_%d_%d total delay	%d ps\n",tra_id,tra_output,total_delay_up);
		//	rep_delay	ns
		//	func_delay	ps
		//ςfBCABUFKvς
		delay_buf_n = delay_to_buf( total_delay_up );
		printf("	BUF1 * %d\n",delay_buf_n);

		//vdt@Cɏ
		write_vnet(vnet_fp, tra_id, tra_output, delay_buf_n ,total_delay_up);
	}
	fclose(vnet_fp);
	fclose(data_fp);

	delete[] delays;


	return 0;

}


